Unit IDS3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IDS3R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y1 :Array of Real;
                var F :Array of Real; var G :Array of Real);

implementation

procedure IDS3R(N :Integer; var X :Array of Real;
                var Y :Array of Real; var Y1 :Array of Real;
                var F :Array of Real; var G :Array of Real);
var
K,N1,N2,J1,J2 :Integer;
H,H1,H2,R1,R2,Z :Real;
label
_1,_2,_3,_4;
begin
N1 := N-1;
G[0] := 0.0;
F[0] := 0.0;
for K:=1 to N1 do
 begin
  J2 := K+1;
  H2 := 1.0/(X[J2-1]-X[K-1]);
  R2 := 3.0*H2*H2*(Y[J2-1]-Y[K-1]);
  if ( K = 1 ) 
   then goto _1;
  Z := 1.0/(2.0*(H1+H2)-H1*G[J1-1]);
  G[K-1] := Z*H2;
  H := R1+R2;
  if ( K = 2 ) 
   then H := H-H1*Y1[0];
  if ( K = N1 ) 
   then H := H-H2*Y1[N-1];
  F[K-1] := Z*(H-H1*F[J1-1]);
_1:
  J1 := K;
  H1 := H2;
  R1 := R2;
_2:
 end;
Y1[N1-1] := F[N1-1];
if ( N1 <= 2 ) 
 then goto _4;
N2 := N1-1;
for J1:=2 to N2 do
 begin
  K := N-J1;
  Y1[K-1] := F[K-1]-G[K-1]*Y1[K+0];
_3:
 end;
_4:
end;

end.
